namespace SampleFewQuiks
{
	using System;
	using System.Collections.Generic;
	using System.Linq;
	using System.Net;
	using System.Threading;
    using System.Security;
	using Ecng.Common;
	using StockSharp.BusinessEntities;
	using StockSharp.Quik;
	using StockSharp.Localization;

	class Program
	{
		private volatile static Portfolio _portfolio1;
		private volatile static Portfolio _portfolio2;
		private volatile static Security _lkoh;
		private volatile static Security _riz0;
		static void Main()	{
			try	{
                var account2 = "*****"; // Console.ReadLine();
//				using (var quikTrader1 = new QuikTrader { LuaFixServerAddress = "127.0.0.1:5001".To<EndPoint>() })
				using (var quikTrader2 = new QuikTrader { LuaFixServerAddress = "193.200.10.92:15100".To<EndPoint>(),
                    LuaLogin = "*****",
                    LuaPassword = "*****".To<SecureString>()  })
				{
			    quikTrader2.Error += OnError;// подписываемся на событие ошибок обработки данных и разрыва соединения
    			quikTrader2.ConnectionError += OnError;
				var portfoliosWait = new ManualResetEvent(false);
				Action<IEnumerable<Portfolio>> newPortfolios = portfolios =>	{
				    if (_portfolio2 == null)
							_portfolio2 = portfolios.FirstOrDefault(p => p.Name == account2);
						if (_portfolio2 != null)	portfoliosWait.Set();
					};
					// подписываемся на события новых портфелей
					quikTrader2.NewPortfolios += newPortfolios;
					var securitiesWait = new ManualResetEvent(false);
					// подписываемся на события новых инструментов
					quikTrader2.NewSecurities += securities =>	{
						if (_lkoh == null)
							_lkoh = securities.FirstOrDefault(s => s.Code == "SBER");
						if (_riz0 == null)
							_riz0 = securities.FirstOrDefault(s => s.Code == "RUAL");
						// если оба инструмента появились
						if (_lkoh != null && _riz0 != null)
							securitiesWait.Set();
					};


					// запускаем экспорты в Quik-ах, когда получим событие об успешном соединении
					quikTrader2.Connected += () =>	{
						Console.WriteLine(LocalizedStrings.Str2994Params.Put(quikTrader2.LuaFixServerAddress));
					};
					// производим подключение каждого из QuikTrader-а
					quikTrader2.Connect();
					Console.WriteLine(LocalizedStrings.Str2995);
					portfoliosWait.WaitOne();
					securitiesWait.WaitOne();
					Console.WriteLine(LocalizedStrings.Str2996);
					if (_lkoh.BestBid == null || _riz0.BestBid == null)
						throw new Exception(LocalizedStrings.Str2990);
					quikTrader2.RegisterOrder(new Order	{
						Portfolio = _portfolio2,
						Volume = 1,
						Security = _riz0,
						Price = _riz0.BestBid.Price
					});
					Console.WriteLine(LocalizedStrings.Str2998);
				}
			}
			catch (Exception ex)	{
				Console.WriteLine(ex);
			}
		}
		private static void OnError(Exception error)	{
			Console.WriteLine(error);
		}
	}
}